/***********************************************/
/*                                             */
/*    STOCKAGE D'UNE IMAGE DANS LA MEMOIRE     */
/*                                             */
/***********************************************/
/*  Programme GETPUT.C                         */
/***********************************************/
/*  Auteur: Patrick Leclercq                   */
/***********************************************/
#include <stdio.h>
#include <conio.h>
#include <graphvga.h>
#include <malloc.h>


/*******************************/
/* REMPLISSAGE DE L'ECRAN      */
/* AVEC DES BARRES DE COULEURS */
/*******************************/
void remplissage_ecran(void)
{
  int px;
  int py;
  int couleur;

  px=0;										/* POSITION X PREMIERE LIGNE */
  py=0;										/* POSITION Y PREMIERE LIGNE */
  for (couleur=0; couleur<200; couleur++)	/* BOUCLE D'AFFICHAGE DES LIGNES */
  {
	 h_line (px, py, 320, couleur);			/* TRACE D'UNE LIGNE DE COULEUR */
	 py++;									/* CALCUL POSITION LIGNE SUIVANTE */
  }
}


/***************************/
/* DEMONSTRATION GRAPHIQUE */
/***************************/
void demo_graph(void)
{
  byte			*tampon_image;
  unsigned int	taille_image;
  int			px, py;
  int			tx, ty;
  int			i;

  px=20;
  py=20;
  tx=50;
  ty=20;
  remplissage_ecran();						/* GENERATION IMAGE DE FOND */

  taille_image = get_taille_image(tx, ty);	/* CALCUL DE LA TAILLE DE LA ZONE MEMOIRE */
  tampon_image = malloc(taille_image);		/* CREATION DE LA ZONE MEMOIRE */
  getch();									/* ATTENTE CLAVIER */

  get_image(px, py, tx, ty, tampon_image);	/* STOCKAGE DE L'IMAGE EN MEMOIRE */
  cls_ecran(3);								/* EFFACEMENT DE L'ECRAN */
  getch();									/* ATTENTE CLAVIER */

  px=5;
  py=5;
  for (i=0; i<10; i++)						/* BOUCLE D'AFFICHAGE DES IMAGES */
  {
	 put_image(px, py, tampon_image);		/* AFFICHAGE IMAGE */
	 px+=20;								/* CALCUL NOUVELLE POSITION X */
	 py+=18;								/* CALCUL NOUVELLE POSITION Y */
  }

  getch();									/* ATTENTE CLAVIER */
  free (tampon_image);						/* LIBERATION DE LA MEMOIRE */
}


/***********************/
/* FONCTION PRINCIPALE */
/***********************/
void main(void)
{
  init_vga();			/* INITIALISATION MODE GRAPHIQUE */
  demo_graph();			/* DEMONSTRATION GRAPHIQUE */
  fermeture_vga();		/* FIN DU MODE GRAPHIQUE */
}

