/*************************************************/
/*                                               */
/*  STRUCTURE D'UN PROGRAMME LISANT LE CLAVIER   */
/*                                               */
/*************************************************/
/*  Programme GESJEU1.C                          */
/*************************************************/
/*  Auteur: Patrick Leclercq                     */
/*************************************************/

#include <stdio.h>
#include <conio.h>


/*****************************************/
/* CONSTANTES SYMBOLIQUE POUR LES ORDRES */
/*****************************************/
#define NON_ORDRE		0
#define ALLER_DROITE	1
#define ALLER_GAUCHE	2
#define TIRER_MISSILE	3
#define FIN_JEU			4


/************************/
/* EXECUTION DES ORDRES */
/************************/
void exec_ordre(int ordre)
{
  if (ordre==ALLER_DROITE)  puts ("Deplacement vers la droite");
  if (ordre==ALLER_GAUCHE)  puts ("Deplacement vers la gauche");
  if (ordre==TIRER_MISSILE) puts ("Lancement d'un missile");
}
  

/**********************/
/* ATTENTE D'UN ORDRE */
/**********************/
int attente_ordre(void)
{
  int c1;
  int c2;
  int ordre;
  
  ordre=NON_ORDRE;						/* INITIALISATION REPONSE PAR DEFAUT */
  
  c1=getch();
  
  if (c1==27)   ordre=FIN_JEU;			/* DETECTION TOUCHE ESC */
  if (c1==32)   ordre=TIRER_MISSILE;	/* DETECTION BARRE D'ESPACE */
  if (c1==0)							/* DETECTION CODE 0 */
  {
    c2=getch();							/* LECTURE SECOND CODE */
    if (c2==75) ordre=ALLER_GAUCHE;		/* TEST SI CODE FLECHE GAUCHE */
    if (c2==77) ordre=ALLER_DROITE;		/* TEST SI CODE FLECHE DROITE */
    if (c2==72) ordre=TIRER_MISSILE;	/* TEST SI CODE FLECHE HAUTE */
  }   
  
  return (ordre);						/* PARAMETRE DE RETOUR DE LA FONCTION */
}
         

/***********************/
/* FONCTION PRINCIPALE */
/***********************/
void main(void)
{
  int ordre;
  
  do {
       ordre=attente_ordre();			/* ATTENTE D'UN ORDRE */
       if (ordre==FIN_JEU) break;		/* TEST SI FIN DU PROGRAMME */
       exec_ordre(ordre);				/* EXECUTION DE L'ORDRE */
     } while (1);
}

