/****************************************/
/*                                      */
/*   LECTURE DE LA POSITION D'IMAGES    */
/*                                      */
/****************************************/
/*  Programme POS_IMGS.C                */
/****************************************/
/*  Auteur: Patrick Leclercq            */
/****************************************/

#include <stdio.h>
#include <conio.h>
#include <graphvga.h>
#include <loadpcx.h>
#include <souris.h>


/**************************/
/* TEST EXISTENCE FICHIER */
/**************************/
int test_existe_fichier(char *nom_fichier)
{
  FILE	*fic;
  int	rep;
            
  rep=0;						/* INITIALISATION INDICATEUR FICHIER */
  fic=fopen(nom_fichier, "rb");	/* OUVERTURE FICHIER */
  if (fic!=NULL)				/* TEST SI ERREUR D'OUVERTURE */
  {
    rep=1;						/* MISE A JOUR INDICATEUR FICHIER */
    fclose (fic);				/* FERMETURE FICHIER */
  }
  return (rep);					/* VARIABLE DE RETOUR DE LA FONCTION */
}


/*************************************/
/* SAISIE D'UNE CHAINE DE CARACTERES */
/*************************************/
int saisie_chaine(char *s)
{
  int n;
  int c;
  
  n=0;
  
  do {
       c=getch();				/* LECTURE TOUCHE */
       
       if (c==13) break;		/* TEST SI TOUCHE [Entre] */
       
       if (c!=8)				/* MEMORISATION CARACTERE */
       {
         n++;					/* INCREMENTATION NB DE CARACTERES */
         *s=c;					/* ECRITURE CARACTERE EN MEMOIRE */
         s++;					/* PASSAGE ADRESSE CARACTERE SUIVANT */
         putchar(c);			/* AFFICHAGE CARACTERE SUR ECRAN */
       }
       
       if ((c==8) && (n!=0))	/* EFFACEMENT DU DERNIER CARACTERE */
       {
         n--;					/* DECREMENTATION NB DE CARACTERES */
         s--;					/* DECREMENTATION ADRESSE COURANTE */
         putchar(8);			/* RETOUR D'UN CARACTERE EN ARRIERE */
         putchar(' ');			/* AFFICHAGE ESPACE POUR EFFACER CARACTERE */
         putchar(8);			/* RETOUR D'UN CARACTERE EN ARRIERE */
       }
      
     } while(1);
  *s=0;							/* FABRICATION CODE DE FIN DE CHAINE */
  putchar(13);					/* PASSAGE A LA LIGNE SUIVANTE */
  return (n);					/* RETOUR TAILLE DE LA CHAINE */
}


void affichage_position_souris(void)
{
  int xm, ym, km;
  int px, py;
  int tx, ty;
  int compteur_clic;

  aff_souris();								/* AFFICHAGE SOURIS */
  compteur_clic=0;							/* INITIALISATION COMPTEUR DE CLIC */
  do {
       att_clic(&xm, &ym, &km);				/* ATTENTE CLIC SOURIS */
       
       if (km==CLIC_DROIT) break;			/* TEST SI FIN DE PROGRAMME */
                         
       if (compteur_clic==0)				/* TEST COMPTEUR DE CLIC */
       {
         px=xm;
         py=ym;
         compteur_clic=1;					/* MEMORISATION PREMIER CLIC */
       }
       else
       {
         tx=xm-px+1;						/* CALCUL TX */
         ty=ym-py+1;						/* CALCUL TY */
         gotoxy(1,1);						/* POSITION CURSEUR */
         eff_souris();						/* EFFACEMENT SOURIS */
         printf ("px:%d py:%d  \n",px, py);	/* AFFICHAGE POSITION SOURIS */
         printf ("tx:%d ty:%d  \n",tx, ty);	/* AFFICHAGE TX et TY */
         aff_souris();						/* AFFICHAGE SOURIS */
         compteur_clic=0;					/* REMISE A ZERO COMPTEUR DE CLIC */
       }
       
     } while(1);
  eff_souris();
}


void main(void)
{
  char nom_image[255];
  int n;
  
  init_vga();											/* PASSAGE EN MODE VGA */
  init_souris();										/* INITIALISATION SOURIS */
  eff_souris();											/* EFFACEMENT SOURIS */
  
  /* SAISIE DU NOM DE L'IMAGE */
  do {
       printf ("Nom image: ");
       n=saisie_chaine(nom_image);						/* ATTENTE NOM FICHIER */
       if (nom_image[0]=='\0') break;					/* FIN SI NOM VIDE */
       if (test_existe_fichier(nom_image)==1) break;	/* FIN SI FICHIER EXISTANT */
       else puts ("Fichier inexistant");
     } while(1);
  
  /* CHARGEMENT IMAGE */
  if (n!=0)												/* TEST SI NOM VIDE */
  {
    load_pcx(nom_image);								/* CHARGEMENT IMAGE */
    affichage_position_souris();						/* ROUTINE DE GESTION DES AFFICHAGES */
  }
  
  fermeture_vga();										/* DESACTIVATION MODE VGA */
}
