/*************************/
/*                       */
/* GENERATEUR DE CARTES  */
/*                       */
/*************************/
#include <stdio.h>
#include <graphvga.h>
#include <loadpcx.h>


#define MAX_CARTES		7

#define TX_CARTE		64
#define TY_CARTE		44

#define DOS_CARTE		0


byte *image_carte[MAX_CARTES];
int taille_carte;


/*********************************************/
/* RESERVATION DE LA MEMOIRE POUR LES CARTES */
/*********************************************/
void reservation_memoire_cartes(void)
{
  int n;
    
  taille_carte=get_taille_image(TX_CARTE, TY_CARTE);
  for (n=0; n<MAX_CARTES; n++)
    image_carte[n]=malloc(taille_carte);
}


void liberation_memoire_cartes(void)
{
  int n;

  for (n=0; n<MAX_CARTES; n++)
    free(image_carte[n]);
}


void stockage_carte(int px, int py, int num_carte)
{
  get_image(px, py, TX_CARTE, TY_CARTE, image_carte[num_carte]);
}


void chargement_graphismes(void)
{ 
  stockage_carte(1,		1,		0);	/* IMAGE DU DOS DES CARTES */
  stockage_carte(66,	1,		1);
  stockage_carte(131,	1,		2);
  stockage_carte(196,	1,		3);
  stockage_carte(131,	46,		4);
  stockage_carte(196,	46,		5);
  stockage_carte(66,	136,	6);
}


void sauver_cartes (char *nom_fichier)
{
   int n;
   FILE *fichier;

   fichier=fopen(nom_fichier, "wb");					/* OUVERTUDE FICHIER */
   for (n=0; n<MAX_CARTES; n++)							/* BOUCLE DE SAUVEGARDE */
     fwrite (image_carte[n], taille_carte, 1, fichier);	/* SAUVER IMAGE CARTE */
   fclose (fichier);									/* FERMETURE FICHIER */
}


void main (void)
{
  init_vga();					/* PASSAGE EN MODE GRAPHIQUE VGA */
  reservation_memoire_cartes();	/* ALLOCATION MEMOIRE */
  load_pcx("cartes.pcx");		/* CHARGEMENT IMAGE PCX */
  chargement_graphismes();		/* STOCKAGE DES CARTES EN MEMOIRE */
  sauver_cartes("cartes.img");  /* SAUVEGARDE DES CARTES SUR LE DISQUE */
  liberation_memoire_cartes();	/* LIBERATION MEMOIRE CARTE */
  fermeture_vga();				/* FERMETURE DU MODE GRAPHIQUE VGA */
}
