/*******************************************/
/*                                         */
/*    GENERATEUR DE SCENARIO DE TYPE       */
/*  "LOGICIEL DONT VOUS ETES LE HEROS"     */
/*                                         */
/*******************************************/
/*  Programme GENERAT.H                    */
/*******************************************/
/*  Auteur: Patrick Leclercq               */
/*******************************************/
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>

typedef unsigned char byte;

#define MAX_OPTIONS		3
#define MAX_EVENEMENTS	255


struct type_lieu
{
  byte	exist;
  char	*situation;
  byte	nb_options;
  char *text_option[MAX_OPTIONS];
  byte 	chainage_option[MAX_OPTIONS];
} liste_ev[MAX_EVENEMENTS];


/*************************************/
/* SAISIE D'UNE CHAINE DE CARACTERES */
/*************************************/
int saisie_chaine(char *s)
{
  int n;
  int c;

  n=0;

  do {
		 c=getch();				/* LECTURE TOUCHE */

		 if (c==13) break;		/* TEST SI TOUCHE [Entre] */

		 if (c!=8)				/* MEMORISATION CARACTERE */
		 {
			n++;					/* INCREMENTATION NB DE CARACTERES */
			*s=c;					/* ECRITURE CARACTERE EN MEMOIRE */
			s++;					/* PASSAGE ADRESSE CARACTERE SUIVANT */
			putchar(c);			/* AFFICHAGE CARACTERE SUR ECRAN */
		 }

		 if ((c==8) && (n!=0))	/* EFFACEMENT DU DERNIER CARACTERE */
		 {
			n--;					/* DECREMENTATION NB DE CARACTERES */
			s--;					/* DECREMENTATION ADRESSE COURANTE */
			putchar(8);			/* RETOUR D'UN CARACTERE EN ARRIERE */
			putchar(' ');			/* AFFICHAGE ESPACE POUR EFFACER CARACTERE */
			putchar(8);			/* RETOUR D'UN CARACTERE EN ARRIERE */
		 }

	  } while(1);
  *s=0;							/* FABRICATION CODE DE FIN DE CHAINE */
  puts("");						/* PASSAGE A LA LIGNE SUIVANTE */
  return (n);					/* RETOUR TAILLE DE LA CHAINE */
}


/**************************/
/* CHARGEMENT D'UNE LIGNE */
/**************************/
int charge_ligne(char *ligne, FILE *fic)
{
  char	c;
  char	*adr_ligne;
  int	rep;

  adr_ligne=ligne;			/* ADRESSE DE LA CHAINE */
  *adr_ligne='\0';			/* ECRITURE CODE FIN DE LIGNE */
  do {
		 c=fgetc(fic);		/* LECTURE CARACTERE */
		 if (c==EOF) break;	/* TEST SI FIN DE FICHIER */
       if (c==10)			/* TEST SI CODE FIN DE LIGNE */
       { 
         *adr_ligne='\0';	/* ECRITURE CODE DE FIN DE CHAINE */
         break;				/* SORTIE DE LA BOUCLE */
       }
       *adr_ligne=c;		/* ECRITURE CARACTERE EN MEMOIRE */
       adr_ligne++;			/* CALCUL ADRESSE CARACTERE SUIVANT */
	  } while(1);			/* FIN DE LA BOUCLE */
  
  if (c==EOF) rep=EOF;
         else rep=1;
  return (rep);
}


void chargement_fichier(char *nom)
{
  FILE	*fic;
  char	ligne[500];
  char	tampon[500];
  char	texte[500];
  char	texte_option[3][255];
  int	chainage_option[3];
  int	nb_options;
  int	n;
  char	c;
  int	num_ev;
  int	rep;
  
  fic=fopen(nom, "rt");
  do {
       rep=charge_ligne(ligne, fic);
       if (rep==EOF) break;
       c=ligne[0];
       if (c=='#')
       {
			strcpy(tampon, ligne+1);					/* SEPARATION DU CODE "#" */
         num_ev=atoi(tampon);
          
         /* CHARGEMENT DE LA DESCRIPTION */
         texte[0]=0;
         do {
				  charge_ligne(ligne, fic);				/* CHARGEMENT LIGNE */
				  if (ligne[0]=='#') break;				/* TEST SI FIN DE TEXTE */
				  strcat(texte, " ");					/* AJOUT D'UN ESPACE */
				  strcat(texte, ligne);					/* CONCATENATION DU TEXTE */
				} while(1);

			/* CHARGEMENT PREMIERE OPTION */
			n=0;
			strcpy(texte_option[n], ligne+1);
			charge_ligne(ligne, fic);					/* CHARGEMENT LIGNE */
			strcpy(tampon, ligne+1);
			chainage_option[n]=atoi(tampon);
			n++;
			/* CHARGEMENT DES OPTIONS */
			do {
				  rep=charge_ligne(ligne, fic);			/* CHARGEMENT LIGNE */
				  if (strlen(ligne)==0)  break;			/* FIN BOUCLE */
				  if (ligne[0]=='#')
				  {
					 strcpy(texte_option[n], ligne+1);
					 charge_ligne(ligne, fic);			/* CHARGEMENT LIGNE */
					 if (ligne[0]=='>')
					 {
						 strcpy(tampon, ligne+1);
						 chainage_option[n]=atoi(tampon);
						 n++;
					 }
				  }
				 } while(1);

			/* STOCKAGE EN MEMOIRE D'UN EVENEMENT */
			printf ("Memorisation ev %d\n", num_ev);
			nb_options=n;
			liste_ev[num_ev].exist=1;
			liste_ev[num_ev].situation=malloc(strlen(texte)+1);
			strcpy(liste_ev[num_ev].situation, texte);
			liste_ev[num_ev].nb_options=nb_options;
			for (n=0; n<nb_options; n++)
			{
			  liste_ev[num_ev].text_option[n]=malloc(strlen(texte_option[n])+1);
			  strcpy(liste_ev[num_ev].text_option[n], texte_option[n]);
			  liste_ev[num_ev].chainage_option[n]=chainage_option[n];
			}

		 }
	  } while(1);

	fclose(fic);
}


void sauvegarde_scenario(char *nom)
{
  FILE *fic;
  int num_ev;
  int n;
  int nb_options;
  int taille;
  int chainage;

  fic=fopen (nom, "wb");

  for (num_ev=0; num_ev<MAX_EVENEMENTS; num_ev++)
	 if (liste_ev[num_ev].exist==1)
	 {
		fwrite (&num_ev, sizeof(num_ev), 1, fic);						/* ECRITURE NUMERO EV */

		taille=strlen(liste_ev[num_ev].situation)+1;					/* CALCUL TAILLE MESSAGE */
		fwrite(&taille, sizeof(taille), 1, fic);						/* ECRITURE TAILLE MESSAGE */
		fwrite(liste_ev[num_ev].situation, taille, 1, fic);			/* ECRITURE MESSAGE */

		nb_options=liste_ev[num_ev].nb_options;						/* LECTURE NB OPTIONS */
		fwrite(&nb_options, sizeof(nb_options), 1, fic);				/* ECRITURE NB OPTIONS */

		for (n=0; n<nb_options; n++)
		{
			taille=strlen(liste_ev[num_ev].text_option[n])+1;			/* CALCUL TAILLE OPTION */
			fwrite(&taille, sizeof(taille), 1, fic);					/* ECRITURE TAILLE MESSAGE */
			fwrite(liste_ev[num_ev].text_option[n], taille, 1, fic);	/* ECRITURE OPTION */
			chainage=liste_ev[num_ev].chainage_option[n];				/* LECTURE CHAINAGE */
			fwrite(&chainage, sizeof(int), 1, fic);					/* ECRITURE CHAINAGE */
		}
    }
   num_ev=-1;														/* CODE FIN DE FICHIER */
   fwrite (&num_ev, sizeof(num_ev), 1, fic);						/* ECRITURE FIN DE FICHIER */
   fclose(fic);														/* FERMETURE FICHIER */
}


void main()
{
  char nom1[100];
  char nom2[100];
    
  printf ("GERATEUR DE SCENARIOS\n");
  printf ("Nom du fichier a lire: ");
  saisie_chaine(nom1);
  puts("");
  
  if (strlen(nom1)!=0)
  {
    printf ("Nom du scenario a generer: ");
    saisie_chaine(nom2);
    if (strlen(nom2)!=0)
    {
      chargement_fichier(nom1);
      sauvegarde_scenario(nom2);
    }
  }
}

