/************************************/
/*                                  */
/*      EXEMPLE DE "LOGICIEL"       */
/*    "DONT VOUS ETES LE HEROS"     */
/*                                  */
/************************************/
/*  Programme HEROS.C               */
/************************************/
/*  Auteur: Patrick Leclercq        */
/************************************/

#include <stdio.h>
#include <conio.h>
#include <malloc.h>

#include <graphvga.h>
#include <texte.h>
#include <souris.h>


#define MAX_OPTIONS 	3
#define MAX_EVENEMENTS	255


#define NOIR			0
#define BLEU_SOMBRE		1
#define VERT_SOMBRE		2
#define ROUGE			4
#define VIOLET			5
#define MARRON			6
#define GRIS			7
#define GRIS_SOMBRE		8
#define VERT			10
#define BLEU			11
#define JAUNE			14


/*****************************************/
/* DEFINITION DE LA LISTE DES EVENEMENTS */
/*****************************************/
struct type_evenement
{
  byte 	exist;
  char	*situation;
  byte	nb_options;
  char	*text_option[MAX_OPTIONS];
  byte	chainage_option[MAX_OPTIONS];
} liste_ev[MAX_EVENEMENTS];


/*******************************************/
/* MEMORISATION DE LA POSITION DES OPTIONS */
/*******************************************/
int px_options[MAX_OPTIONS];
int py_options[MAX_OPTIONS];
int tx_options[MAX_OPTIONS];
int ty_options[MAX_OPTIONS];
int nb_options;


/*************************/
/*                       */
/*  FORMATAGE DE TEXTE   */
/*                       */
/*************************/
#define MAX_LIGNES_FORMATAGE	20

char ligne_formatage[MAX_LIGNES_FORMATAGE][80];
int  nb_lignes_formatage;


/************************************************/
/* FORMATAGE D'UN TEXTE SELON UN GABARIT PRECIS */
/************************************************/
void formatage_texte(char *texte, int max_lettres)
{
  char tampon[200];
  char ligne[200];
  char c;
  char string_c[2];
  int  p;

  nb_lignes_formatage=0;
  tampon[0]='\0';
  ligne[0]='\0';

  for (p=0; p<MAX_LIGNES_FORMATAGE; p++)
	 ligne_formatage[p][0]='\0';

  /* BOUCLE DE DECOUPAGE */
  for (p=0; p<strlen(texte); p++)
  {
	 c=texte[p];
	 if (c!=' ')
		  {
			 string_c[0]=c;
			 string_c[1]='\0';
			 strcat (tampon, string_c);
		  }
	 else
		if (((int)strlen(ligne)+1+(int)strlen(tampon))<=max_lettres)
			if (strlen(ligne)==0)
			{
			  strcpy(ligne, tampon);
			  tampon[0]='\0';
			} else
			{
			  strcat(ligne, " ");
			  strcat(ligne, tampon);
			  tampon[0]='\0';
			}
		else
		  {
			 strcpy(ligne_formatage[nb_lignes_formatage], ligne);
			 nb_lignes_formatage++;
			 ligne[0]='\0';
			 if (strlen(tampon)!=0)
				strcat(tampon, " ");
		  }
  }

  /* FIN DU DECOUPAGE */
  if ((strlen(ligne)==0) && (strlen(tampon)!=0))
  {
	 strcpy(ligne_formatage[nb_lignes_formatage], tampon);
	 nb_lignes_formatage++;
	 tampon[0]='\0';
  }

  if ((strlen(tampon)!=0) && (strlen(ligne)!=0))
	 if (((int)strlen(ligne)+1+(int)strlen(tampon))<=max_lettres)
		{
			strcpy(ligne_formatage[nb_lignes_formatage], ligne);
			strcat(ligne_formatage[nb_lignes_formatage], " ");
			strcat(ligne_formatage[nb_lignes_formatage], tampon);
			nb_lignes_formatage++;
			ligne[0]='\0';
			tampon[0]='\0';
		} else
		{
		  strcpy(ligne_formatage[nb_lignes_formatage], ligne);
		  nb_lignes_formatage++;
		  ligne[0]='\0';
		  strcpy(ligne_formatage[nb_lignes_formatage], tampon);
		  nb_lignes_formatage++;
		  tampon[0]='\0';
		}
}


/******************************/
/* AFFICHAGE DU TEXTE FORMATE */
/******************************/
void affichage_texte_formatage(int px, int py, char *texte, int taille_ligne)
{
  int ligne;

  formatage_texte(texte, taille_ligne);
  for (ligne=0; ligne<nb_lignes_formatage; ligne++)
  {
	 aff_message(px, py, ligne_formatage[ligne]);
	 py+=9;
  }
}


/************************************/
/* DESSIN DE LA ZONE DE DESCRIPTION */
/************************************/
void dessin_zone_description(void)
{
  bloc (10, 13, 300, 125, GRIS, NOIR);
}


/*********************************/
/* DESSIN DE LA ZONE DES OPTIONS */
/*********************************/
void dessin_zone_options(void)
{
  bloc (10, 148, 300, 42, GRIS, NOIR);
}


/*******************************/
/* AFFICHAGE DE L'ECRAN DE JEU */
/*******************************/
void aff_ecran_jeu(void)
{
  cls_ecran(VERT);				/* COULEUR DE FOND DE L'ECRAN */
  dessin_zone_description();	/* DESSIN ZONE DE DESCRIPTION */
  dessin_zone_options();		/* DESSIN ZONE DES OPTIONS */
}


/****************************/
/* AFFICHAGE D'UN EVENEMENT */
/****************************/
void affichage_evenement(int num_ev)
{
  char	*texte;
  char	*texte_option;
  int	n;

  dessin_zone_description();								/* EFFACEMENT ZONE D'AFFICHAGE */
  texte=liste_ev[num_ev].situation;							/* LECTURE ADRESSE TEXTE */
  affichage_texte_formatage(23, 25, texte, 34); 			/* AFFICHAGE TEXTE */

  dessin_zone_options();									/* EFFACEMENT ZONE D'AFFICHAGE */
  nb_options=liste_ev[num_ev].nb_options;					/* LECTURE NB OPTIONS */

  for (n=0; n<nb_options; n++)								/* BOUCLE D'AFFICHAGE */
  {
	 texte_option=liste_ev[num_ev].text_option[n];			/* LECTURE TEXTE OPTION */
	 tx_options[n]=strlen(texte_option)*8;					/* CALCUL TX OPTION */
	 px_options[n]=10+(300-tx_options[n])/2;					/* CALCUL PX OPTION */
	 ty_options[n]=8;										/* CALCUL PY OPTION */
	 if (nb_options==1) py_options[0]=165;
	 if (nb_options==2) py_options[n]=156+n*16;
	 if (nb_options==3) py_options[n]=153+n*12;				/* CALCUL PY OPTION */
	 aff_message(px_options[n], py_options[n], texte_option);/* AFFICHAGE TEXTE OPTION */
  }
}


/*****************************************/
/* LECTURE DU NOUVEAU NUMERO D'EVENEMENT */
/*****************************************/
int lecture_chainage(int num_ev, int option)
{
  int ev;

  ev=liste_ev[num_ev].chainage_option[option];
  return (ev);
}


/*********************************/
/* INITIALISATION DES EVENEMENTS */
/*********************************/
void init_evenements(void)
{
  int n;

  for (n=0; n<MAX_EVENEMENTS; n++)
	 liste_ev[n].exist=0;
}


/***************************************/
/* VERIFICATION SI UN EVENEMENT EXISTE */
/***************************************/
int test_exist_evenement(int ev)
{
  return (liste_ev[ev].exist);
}


/****************************/
/* EFFACEMENT D'UN SCENARIO */
/****************************/
void efface_scenario(void)
{
  int num_ev;
  int nb_options;
  int n;

  for (num_ev=0; num_ev<MAX_EVENEMENTS; num_ev++)	/* BOUCLE D'EFFACEMENT */
	 if (liste_ev[num_ev].exist==1)					/* TEST SI EXISTENCE EVENEMENT */
	 {
		 liste_ev[num_ev].exist=0;					/* MARQUAGE EVENEMENT EFFACE */
		 free (liste_ev[num_ev].situation);			/* LIBERATION MEMOIRE DESCRIPTION */
		 nb_options=liste_ev[num_ev].nb_options;		/* LECTURE NB OPTIONS */
		 for (n=0; n<nb_options; n++)					/* BOUCLE EFFACEMENT OPTIONS */
			free (liste_ev[num_ev].text_option[n]);	/* EFFACEMENT TEXTE OPTION */
	 }
}


/***************************************/
/* CHARGEMENT D'UN SCENARIO EN MEMOIRE */
/***************************************/
void chargement_scenario(char *nom)
{
  FILE *fic;
  int num_ev;
  int n;
  int nb_options;
  int taille;
  int chainage;

  fic=fopen (nom, "rb");										/* OUVERTURE FICHIER */

  do {
		fread (&num_ev, sizeof(num_ev), 1, fic);					/* CHARGEMENT NUMERO EV */

		if (num_ev==-1) break;									/* TEST SI FIN DE FICHIER */

		liste_ev[num_ev].exist=1;									/* MARQUAGE DE L'EVENEMENT */

		fread(&taille, sizeof(taille), 1, fic);					/* CHARGEMENT TAILLE MESSAGE */
		liste_ev[num_ev].situation=malloc(taille);				/* RESERVATION MEMOIRE */
		fread(liste_ev[num_ev].situation, taille, 1, fic);		/* CHARGEMENT MESSAGE */

		fread(&nb_options, sizeof(nb_options), 1, fic);			/* CHARGEMENT NB OPTIONS */
		liste_ev[num_ev].nb_options=nb_options;					/* MEMORISATION NB OPTIONS */

		for (n=0; n<nb_options; n++)
		{
		  fread(&taille, sizeof(taille), 1, fic);					/* CHARGEMENT TAILLE MESSAGE */
		  liste_ev[num_ev].text_option[n]=malloc(taille);			/* RESERVATION MEMOIRE */
		  fread(liste_ev[num_ev].text_option[n], taille, 1, fic);	/* CHARGEMENT TEXTE */

		  fread(&chainage, sizeof(int), 1, fic);					/* CHARGEMENT NUMERO DE CHAINAGE */
		  liste_ev[num_ev].chainage_option[n]=chainage;			/* MEMORISATION CHAINAGE */
		}
	 } while(1);
	fclose(fic);													/* FERMETURE FICHIER */
}


/************************************/
/* DETERMINATION DE L'OPTION JOUEUR */
/************************************/
int identification_option(int xm, int ym)
{
  int px, py;
  int tx, ty;
  int rep;
  int n;

  rep=-1;									/* INITIALISATION REPONSE */
  for (n=0; n<nb_options; n++)				/* BOUCLE DE DE RECHERCHE */
  {
	 px=px_options[n];						/* LECTURE PX ZONE OPTION */
	 py=py_options[n];						/* LECTURE PY ZONE OPTION */
	 tx=tx_options[n];						/* LECTURE TX ZONE OPTION */
	 ty=ty_options[n];						/* LECTURE TY ZONE OPTION */
	 if (tst_zone(xm, ym, px, py, tx, ty))	/* TEST SI XM,YM EST DANS LA ZONE */
		rep=n;								/* MEMORISATION NUMERO ZONE */
  }
  return (rep);
}


void gestion_jeu(void)
{
  int xm, ym;
  int clic;
  int num_option;
  int num_ev;
  int nouveau_ev;

  num_ev=1;														/* EVENEMENT DE DEBUT */
  eff_souris();													/* EFFACEMENT SOURIS */
  affichage_evenement(num_ev);									/* AFFICHAGE EVENEMENT */
  aff_souris();													/* AFFICHAGE SOURIS */
  do {
		att_clic(&xm, &ym, &clic);								/* ATTENTE CLIC SOURIS */
		if (clic==CLIC_DROIT) break;								/* TEST SI FIN JEU */
		num_option=identification_option(xm, ym);					/* IDENTIF NUMERO OPTION */
		if (num_option!=-1)										/* TEST SI SELECTION D'UNE OPTION */
		{
		  nouveau_ev=lecture_chainage(num_ev, num_option);		/* LECTURE CHAINAGE */
		  eff_souris();											/* EFFACEMENT SOURIS */
		  if (test_exist_evenement(nouveau_ev)==0)				/* TEST SI ERREUR DE CHAINAGE */
		  {
			 printf ("Erreur evenement %d\n", num_ev);				/* AFF ERREUR DE CHAINAGE */
			 printf ("Le chainage %d n'existe pas!", nouveau_ev);
		  }
		  else
			 affichage_evenement(nouveau_ev);						/* AFFICHAGE NOUVEAU EVENEMENT */
		  aff_souris();											/* AFFICHAGE SOURIS */
		  num_ev=nouveau_ev;										/* MEMORISATION NUMERO EVEMENENT */
		}
	  } while(1);
}


void main(void)
{
   init_vga();							/* INITIALISATION MODE VGA */
   charger_caracteres("police.car");	/* CHARGEMENT POLICE DE CARACTERES */
   init_souris();						/* EFFACEMENT SOURIS */
   eff_souris();						/* EFFACEMENT SOURIS */
	init_evenements();					/* INITIALISATION DES EVENEMENTS */
   
   chargement_scenario("chateau.bin");	/* CHARGEMENT MODULE DE JEU */
   
   aff_ecran_jeu();						/* DESSIN DE L'ECRAN DE JEU */
   aff_souris();						/* AFFICHAGE SOURIS */

   gestion_jeu();						/* APPEL ROUTINE PRINCIPALE */
   
   eff_souris();						/* EFFACEMENT SOURIS */
   efface_scenario();					/* RECUPERATION MEMOIRE SCENARIO */
   fermeture_vga();						/* DESACTIVATION MODE VGA */
}
