/*******************************************/
/*  GESTION DE LA TRAJECTOIRE D'UNE BALLE  */
/*******************************************/

#include <stdio.h>
#include <graphvga.h>
#include <conio.h>
#include <math.h>


double pi = 3.1415926535;
  
int d;
int Aincr, Bincr, yincr;
int xincr;
int x_trajectoire;
int y_trajectoire;
int debut_trajectoire;
int type_ligne;
 

/****************************************************/
/*  PRELIMINAIRES POUR LE CALCUL DE LA TRAJECTOIRE  */
/****************************************************/
void preparation_trajectoire(int px, int py, int angle)
{
  double dx;
  double dy;
  
  debut_trajectoire=1;
  
  dx=cos((pi*angle)/180)*100;
  if (dx>=0) xincr=1;
  else
  {
    xincr=-1;
    dx=-dx;
  }

  dy=sin((pi*angle)/180)*100;
  if (dy>=0) yincr=1;
  else
  {
    yincr=-1;
    dy=-dy;
  }
  
  if (dx>=dy)					/* PENTE COMPRISE ENTRE 0 ET 1 */
  {
    type_ligne=1;
    d = (int)(2*dy-dx);
    Aincr = (int)(2*(dy-dx));
    Bincr = (int)(2*dy);
  }
  
  if (dx<dy)					/* PENTE COMPRISE ENTRE 1 et INFINI */
  {
    type_ligne=2;
    d = (int)(2*dx-dy);
    Aincr = (int)(2*(dx-dy));
    Bincr = (int)(2*dx);  
  }

  if (dx==dy) type_ligne=3;		/* TEST SI LIGNE A 45 */

  if (dx==0)					/* TEST SI LIGNE VERTICALE */
  {
    type_ligne=3;
    xincr=0;
  }
  
  if (dy==0)					/* TEST SI LIGNE HORIZONTALE */
  {
    type_ligne=3;
    yincr=0;
  }

  yincr=-yincr;					/* INVERSION DU SENS DES Y */
  x_trajectoire = px;
  y_trajectoire = py;
}



void lecture_trajectoire (int *adr_px, int *adr_py)
{

  if (debut_trajectoire==1) debut_trajectoire=0;
  else
  switch (type_ligne)
  {
  case 1:
    x_trajectoire += xincr;
    if (d<0)  d += Bincr;
    else
    {
      y_trajectoire += yincr;
      d += Aincr;
    }
    break;           
    
  case 2:
    y_trajectoire += yincr;
    if (d<0)  d += Bincr;
    else
    {
      x_trajectoire += xincr;
      d += Aincr;
    }
    break;
   
  case 3:			/* LIGNE A 45 OU VERTICALE OU HORIZONTALE */   
    x_trajectoire += xincr;
    y_trajectoire += yincr;
  }
    
  *adr_px=x_trajectoire;
  *adr_py=y_trajectoire;
}


void exec_trajectoire(int px, int py, int angle, int c)
{
  int n;
  
  preparation_trajectoire(px, py, angle);
  for (n=0; n<50; n++)
  {
    lecture_trajectoire(&px, &py);
    put_pixel(px, py, c);
  }
}


void test(void)
{ 
  int angle;
  
  getch();
  angle=30;
  printf ("angle: %d\n", angle);
  exec_trajectoire(100, 100, angle, 3);
  getch();
  
  angle=-30;
  printf ("angle: %d\n", angle);
  exec_trajectoire(100, 100, angle, 4);
  getch();
  
  angle=150;
  printf ("angle: %d\n", angle);
  exec_trajectoire(100, 100, 150, 5);
  getch();
  
  angle=-150;
  printf ("angle: %d\n", angle);
  exec_trajectoire(100, 100, angle, 6);
  getch();
  
  angle=55;
  printf ("angle: %d\n", angle);
  exec_trajectoire(100, 100, angle, 7);
  getch();   
  
  angle=45;
  printf ("angle: %d\n", angle);
  exec_trajectoire(100, 100, angle, 9);
  getch();
  
  angle=120;
  printf ("angle: %d\n", angle);
  exec_trajectoire(100, 100, angle, 9);
  getch();
}


void main(void)
{
  init_vga();
  
  test();
  
  fermeture_vga();
}
