/***************************************/
/*                                     */
/*     CHARGEMENT D'UNE IMAGE PCX      */
/*   MODE VGA 320x200 - 256 COULEURS   */
/*                                     */
/***************************************/
/*  Programme LOADPCX.H                */
/***************************************/
/*  Auteur: Patrick Leclercq           */
/***************************************/
#ifndef _LOADPCX

#include <string.h>
#include <graphvga.h>


/*****************************************/
/* MODIFICATION DE LA PALETTE DE COULEUR */
/*****************************************/
void setpalette(unsigned char *pal)
{
  union  REGS  reg;
  struct SREGS regs;
  
  reg.x.ax = 0x1012;
  regs.es=FP_SEG(pal);
  reg.x.dx=FP_OFF(pal);
  reg.x.bx=0x0;
  reg.x.cx=256;
  int86x(0x10, &reg, &reg, &regs);
}


/************************/
/* CHARGEMENT IMAGE PCX */
/************************/
int load_pcx(char *nom_fichier)
{ 
  FILE          *fic;
  unsigned char *adr_pixel;
  unsigned char octet;
  int           nb_octets;
  long 			nb_pixels;
  int			couleur;
  int 			rouge;
  int			vert;
  int			bleu;
  unsigned char pal[256][3];
  int			presence_image;
  
  presence_image=0;
  fic = fopen(nom_fichier, "rb");
  
  if (fic!=NULL)
  {             
    presence_image=1;
    
    /* LECTURE DE LA PALETTE DE COULEURS */
    fseek(fic, -768, SEEK_END);
    for (couleur=0; couleur<256; couleur++)
    {
      rouge=(64*getc(fic))/256;
      vert=(64*getc(fic))/256;
      bleu=(64*getc(fic))/256;
      pal[couleur][0]=rouge;
      pal[couleur][1]=vert;
      pal[couleur][2]=bleu;
    }
    setpalette(&pal[0][0]);
  
    /* LECTURE DE L'IMAGE */
    fseek(fic, 128, SEEK_SET);
	 adr_pixel=MK_FP(0xA000,0x0);
	 nb_pixels=0;
	 do {
			octet = getc(fic);
			if ((octet & 0xC0)!=0xC0)
			{
			  *adr_pixel=octet;
			  adr_pixel++;
			  nb_pixels++;
			}
			else
			{
			  nb_octets = octet & 0x3F;
			  octet=getc(fic);
			  memset(adr_pixel, octet, nb_octets);
			  adr_pixel+=nb_octets;
			  nb_pixels+=nb_octets;
			}
		 if (nb_pixels==64000u) break;
		} while(1);
	 fclose (fic);
	}
 return (presence_image);
}


#define _LOADPCX
#endif
