/***********************************************/
/*                                             */
/*    AFFICHAGE D'UNE POLICE DE CARACTERES     */
/*       MODE VGA 320x200 - 256 COULEURS       */
/*                                             */
/***********************************************/
/*  Bibliothque TEXTE.H                       */
/***********************************************/
/*  Auteur: Patrick Leclercq                   */
/***********************************************/

#ifndef _TEXTE

#include <malloc.h>
#include <string.h>
#include <graphvga.h>


#define MAX_CARACTERES 		256

#define TX_CARACTERE 		8
#define TY_CARACTERE		8
#define TAILLE_CARACTERE	68


byte image_caractere[MAX_CARACTERES][TAILLE_CARACTERE];


/****************************/
/* AFFICHAGE D'UN CARACTERE */
/****************************/
void aff_caractere (int px, int py, int c)
{
  put_image(px, py, image_caractere[c]);	/* AFFICHAGE IMAGE */
}


/**************************/
/* AFFICHAGE D'UN MESSAGE */
/**************************/
void aff_message (int px, int py, unsigned char *message)
{
  unsigned char c;
  
  do {
       c=*message;					/* LECTURE CARACTERE */
       message++;					/* CALCUL ADRESSE SUIVANTE */
       if (c=='\0') break;			/* TEST SI FIN DE CHAINE */
       aff_caractere(px, py, c);	/* AFFICHAGE CARACTERE */
       px+=TX_CARACTERE;			/* CALCUL POSITION LETTRE SUIVANTE */
     } while (1);
}


/************************************/
/* AFFICHAGE D'UNE VALEUR NUMERIQUE */
/************************************/
void aff_chiffre(int px, int py, int valeur)
{
  char texte[100];
  
  itoa (valeur, texte, 10);		/* CONVERSION CHIFFRE -> CHAINE DE CARACTERES */
  aff_message(px, py, texte);	/* AFFICHAGE CHAINE DE CARACTERES */
}


/******************************************/
/* AFFICHAGE D'UN TEXTE DANS UN RECTANGLE */
/******************************************/
void aff_texte_rectangle (int px, int py, int tx, int ty, unsigned char *texte, int couleur)
{
  int x_text;
  int y_text;
  
  x_text=px+((tx-strlen(texte)*TX_CARACTERE))/2;	/* CENTRAGE SUR L'AXE X */
  y_text=py+1+((ty-TY_CARACTERE)/2);				/* CENTRAGE SUR L'AXE Y */
  rectangle(px, py, tx, ty, couleur);				/* AFFICHAGE RECTANGLE */
  cadre(px, py, tx, ty, 0);							/* AFFICHAGE CADRE */
  aff_message(x_text, y_text, texte);				/* AFFICHAGE MESSAGE */
}


/******************************************/
/*  SAUVEGARDE DES CARACTERES SUR DISQUE  */
/******************************************/
void sauver_caracteres(char *nom_fichier)
{
  FILE *fichier;
  int	n;
  
  fichier=fopen(nom_fichier, "wb");
  for (n=32; n<MAX_CARACTERES; n++)
    fwrite(image_caractere[n], TAILLE_CARACTERE, 1, fichier);
  fclose (fichier);  
}


/**************************************************/
/*  CHARGEMENT DES CARACTERES A PARTIR DU DISQUE  */
/**************************************************/
void charger_caracteres(char *nom_fichier)
{
  FILE *fichier;
  int	n;
  
  fichier=fopen(nom_fichier, "rb");  							/* OUVERTURE FICHIER */
  for (n=32; n<MAX_CARACTERES; n++)								/* BOUCLE DE CHARGEMENT */
    fread(image_caractere[n], TAILLE_CARACTERE, 1, fichier);	/* LECTURE IMAGE */
  fclose (fichier);  											/* FERMETURE FICHIER */
}
 
 
#define _TEXTE
#endif
  